<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/11/2004 *
 * ================                             Last change: 10/11/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-cache.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Caching system for SQL tables on hard disc       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Caching-System zum Auslagern von SQL-Tabellen    *
 *                     auf der Festplatte des Servers                   *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.1.7";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6", "0.0.7", "0.0.8", "0.0.9", "0.1.0", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_update bigint(20) not null default '3600'";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_path varchar(255) not null default 'cache/'";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_tested tinyint(1) not null default '0'";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_cache', 'Cache-Einstellungen', 'Update-Interval des Caches usw. k&ouml;nnen Sie hier &auml;ndern.', 9)";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE what='config_cache' OR what='cache_stats' LIMIT 2";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config DROP cache_update";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config DROP cache_path";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config DROP cache_tested";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Es wurde die Zeitmarke der Cache-Datei extensions.cache mit ber&uuml;cksichtigt. Dies hatte die Folge, dass wenn bei einem Gast die Datei aktualisiert wurde, nur aktivierte und nicht die deaktivierten mit geladen wurden. Folglich fiehlen einfach ein paar Erweiterungen aus.";
		break;

	case "0.0.2": // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.0.3": // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Cache-Update repariert.";
		break;

	case "0.0.4": // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		if (EXT_IS_ACTIVE("cache"))
		{
			// Check for cache when extension is already installed
			if ($CACHE->cache_file("extensions", true)) $CACHE->cache_destroy();
		}
		$UPDATE_NOTES = "Spalte &quot;keep_active&quot; ist hinzugef&uuml;gt. Cache wurde reinitialisiert.";
		break;

	case "0.0.5": // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Registrierung der Cache-Erweiterung repariert";
		break;

	case "0.0.6": // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Validierung der Cache-Datei admins.cache integriert.";
		break;

	case "0.0.7": // SQL queries for v0.0.7
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD db_hits bigint(20) not null default '0'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_hits bigint(20) not null default '0'";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('stats', 'cache_stats', 'DB-Cache', 'Auf Cache und gesamte Datenbank registrierte Anfragen anzeigen.', 4)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Hits auf den Cache werden gez&auml;hlt.";
		break;

	case "0.0.8": // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Das Umschreiben der Cache-Daten hat eine Fehlermeldung <STRONG>Falsches Passwort!</STRONG> im Admin-Bereich verursacht.";
		break;

	case "0.0.9": // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Interne Datenfeld-Management korregiert und Cache-Statistiken korregiert.";
		break;

	case "0.1.0": // SQL queries for v0.1.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit fehlender admins-Erweiterung beseitigt.";
		break;

	case "0.1.1": // SQL queries for v0.1.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler <STRONG>Division durch 0</STRONG> repariert in den DB-Cache Statistiken.";
		break;

	case "0.1.2": // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Die Tabelen <STRONG>"._MYSQL_PREFIX."_config</STRONG>, <STRONG>"._MYSQL_PREFIX."_refsystem</STRONG>, <STRONG>"._MYSQL_PREFIX."_refdepths</STRONG> und <STRONG>"._MYSQL_PREFIX."_mod_reg</STRONG> werden nun auch ausgelagert.";
		break;

	case "0.1.3": // SQL queries for v0.1.3
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_admins enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_acls enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_exts enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_config enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_modreg enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_refdepth enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD cache_refsys enum('Y', 'N') not null default 'Y'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Alle cache-baren Tabellen sind nun einzelnt ein- bzw. ausschaltbar. Falls die eine oder andere ausgelagerte Tabelle also Fehler verursachen sollte, so k&ouml;nnen Sie diese hier abschalten. Beachten Sie aber bitte, dass dann mehr Abfragen an die Datenbank gestellt wird und dies bedeutend mehr Zeit braucht, als nur die Daten aus einem Datenfeld zu laden, das sich im Speicher aufh&auml;lt.";
		break;

	case "0.1.4": // SQL queries for v0.1.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler <STRONG>Division durch 0</STRONG> repariert in <STRONG>inc/load_cache.php</STRONG>.";
		break;

	case "0.1.5": // SQL queries for v0.1.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Weitere Fehler im System beseitigt.";
		break;

	case "0.1.6": // SQL queries for v0.1.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Probleme w&auuml;hrend des Installationsvorganges beseitigt.";
		break;

	case "0.1.7": // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "CSS-Klassenname gefixt in Templates.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	$DUMMY = LOAD_CONFIG("0");

	// Load config and destroy dummy array
	$CONFIG['cache_update']   = $DUMMY['cache_update'];   // Last time the cache files are been re-created
	$CONFIG['cache_path']     = $DUMMY['cache_path'];     // Relative path for the cache files to 'inc/'
	$CONFIG['cache_tested']   = $DUMMY['cache_tested'];   // Says if cache path is tested or not
	$CONFIG['db_hits']        = $DUMMY['db_hits'];        // Counted hits on the database (all!)
	$CONFIG['cache_hits']     = $DUMMY['cache_hits'];     // Counted hits on the cache arrays in memory
	$CONFIG['cache_admins']   = $DUMMY['cache_admins'];   // Is the table '_admins' cacheable?
	$CONFIG['cache_acls']     = $DUMMY['cache_acls'];     // Is the table '_admins_acls' cacheable?
	$CONFIG['cache_exts']     = $DUMMY['cache_exts'];     // Is the table '_extensions' cacheable?
	$CONFIG['cache_config']   = $DUMMY['cache_config'];   // Is the table '_config' cacheable?
	$CONFIG['cache_modreg']   = $DUMMY['cache_modreg'];   // Is the table '_mod_reg' cacheable?
	$CONFIG['cache_refdepth'] = $DUMMY['cache_refdepth']; // Is the table '_refdepths' cacheable?
	$CONFIG['cache_refsys']   = $DUMMY['cache_refsys'];   // Is the table '_refsystem' cacheable?
	unset($DUMMY);

	// Create instance on class
	if ($CACHE_FILE != "init")
	{
		// Initialize cache system only when it's needed
		$CACHE = new mxchange_cache($CONFIG['cache_update'], PATH."inc/".$CONFIG['cache_path'], $CONFIG['cache_tested']);
		if ($CACHE->ret != "done")
		{
			// Failed to initialize cache sustem
			ADD_FATAL(__FILE__."(".__LINE__."): ".CACHE_CANNOT_INITIALIZE);
		}
	}
	break;
}
// Language file prefix
$EXT_LANG_PREFIX = "cache";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "N";

//
?>
