<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/15/2003 *
 * ===============                              Last change: 04/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-logs.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Management for access log files                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Management fuer Zugriffslogbuecher               *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (!empty($_GET['access'])) {
	// Secure input and construct FQFN
	$access = SQL_ESCAPE(strip_tags($_GET['access']));
	$target = sprintf("%slogs/%s", PATH, $access);

	// Is the file valid and readable?
	if ((file_exists($target)) && (is_readable($target))) {
		// Load it directly
		$content = implode("", file($target));

		// Set header
		if (substr($access, -3, 3) == "log") {
			header("Content-Type: text/plain");
		} elseif (substr($access, -3, 3) == ".gz") {
			header("Content-Type: text/plain");
		} else {
			LOAD_TEMPLATE("admin_settings_saved", false, UNKNOWN_LOGFILE_FORMAT_1.$access.UNKNOWN_LOGFILE_FORMAT_2);
			return;
		}

		// Clean content
		ob_end_clean();

		// Output the logfile's content and exit
		print($content);
		exit;
	} else {
		// Not readable!
		LOAD_TEMPLATE("admin_settings_saved", false, LOGFILE_NOT_READABLE_1.$access.LOGFILE_NOT_READABLE_2);
	}
} else {
	// List access logfiles
	$dir = PATH.LOGS_BASE."/";
	if (is_dir($dir)) {
		// logs directory does exist
		OUTPUT_HTML ("<OL>");
		$handle = @opendir($dir) or mxchange_die("Cannot open directory ".LOGS_BASE."!");
		while($file = @readdir($handle)) {
			// We currenly only like files with "access" as prefix, should be more flexible!
			if (substr($file, 0, 6) == "access") {
				// Okay, let us print it out
				OUTPUT_HTML ("<LI><A href=\"".URL."/modules.php?module=admin&amp;what=".$GLOBALS['what']."&access=".urlencode($file)."\">".$file."</A></LI>");
			}
		}
		@closedir($handle);
		OUTPUT_HTML ("</OL>");
	}
	 else
	{
		// logs directory does not exist
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_LOGS_DIR_404_1.LOGS_BASE.ADMIN_LOGS_DIR_404_2);
	}
}

//
?>
