<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/19/2003 *
 * ===============                              Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-refbanner.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Manage all referral banner                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Banner f�r die Ref-Links verwalten          *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

global $link;

$SEL = 0;
if ((empty($_POST['url'])) || (empty($_POST['alternate'])))
{
	unset($_POST['ok']);
}
if (!empty($_POST['sel'])) $SEL = SELECTION_COUNT($_POST['sel']);

OPEN_TABLE("100%", "admin_content admin_content_align", "");
if (isset($_POST['ok']))
{
	// Fix older calls from add-new-banner-form
	if (empty($_GET['mode'])) $_GET['mode'] = "add";
	$SQL = "";
	switch ($_GET['mode'])
	{
	case "add":
		// Check if banner is already added
		$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_refbanner WHERE url='%s' LIMIT 1",
		 array($_POST['url']), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 0)
		{
			// Add banner
			$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_refbanner (url, alternate, visible)
VALUES ('%s', '%s', '%s')",
 array($_POST['url'], $_POST['alternate'], $_POST['visible']), __FILE__, __LINE__);
		}
		 else
		{
			// Free memory
			SQL_FREERESULT($result);
		}
		break;

	case "edit": // Update banner
		foreach ($_POST['sel'] as $id=>$sel)
		{
			// Secure ID
			$id = bigintval($id);

			// Update entry
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_refbanner SET url='%s', alternate='%s', visible='%s' WHERE id=%d LIMIT 1",
			 array(stripslashes($_POST['url'][$id]), $_POST['alternate'][$id], $_POST['visible'], $id), __FILE__, __LINE__);
		}
		break;
	}
	if (SQL_AFFECTEDROWS($link, __FILE__, __LINE__) == 1)
	{
		$content = "<SPAN class=\"admin_done\">".SETTINGS_SAVED."</SPAN>";
	}
	 else
	{
		$content = "<SPAN class=\"admin_failed\">".SETTINGS_NOT_SAVED."</SPAN>";
	}
	LOAD_TEMPLATE("admin_settings_saved", false, $content);
}
 elseif (($SEL > 0) && (isset($_POST['edit'])))
{
	// Edit banner
	$SW = ""; $OUT = "";
	foreach ($_POST['sel'] as $id=>$sel)
	{
		// Load data
		$result = SQL_QUERY_ESC("SELECT url, alternate, visible FROM "._MYSQL_PREFIX."_refbanner WHERE id=%d LIMIT 1",
		 array(bigintval($id)), __FILE__, __LINE__);
		list($url, $alt, $vis) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Preapre data for the row
		$content = array(
			'sw'  => $SW,
			'id'  => $id,
			'url' => $url,
			'alt' => $alt,
			'vis' => ADD_SELECTION("yn", $vis   , "visible"),
		);

		// Load row template and switch color
		$OUT .= LOAD_TEMPLATE("admin_refbanner_edit_row", true, $content);
		$SW = 3 - $SW;
	}
	define('__BANNER_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_refbanner_edit");
}
 else
{
	if (($SEL > 0) && (isset($_POST['del'])))
	{
		// Delete banner
		foreach ($_POST['sel'] as $id=>$sel)
		{
			$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_refbanner WHERE id=%d LIMIT 1",
			 array(bigintval($id)), __FILE__, __LINE__);
		}
	}

	// Referral levels
	$result = SQL_QUERY("SELECT id, url, alternate, visible, counter, clicks FROM "._MYSQL_PREFIX."_refbanner ORDER BY url", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0)
	{
		// Make referral banner editable and deletable
		$SW = 2; $OUT = "";
		while (list($id, $url, $alt, $vis, $cntr, $clks) = SQL_FETCHROW($result))
		{
			// Preapre data for the row
			$content = array(
				'sw'  => $SW,
				'id'  => $id,
				'url' => $url,
				'alt' => $alt,
				'vis' => TRANSLATE_YESNO($vis),
				'cnt' => $cntr,
				'clx' => $clks
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_refbanner_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__BANNER_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_refbanner");
	}

	// Form for adding new referral levels
	LOAD_TEMPLATE("admin_add_banner");
}
CLOSE_TABLE();
//
?>
